<template>
  <ob-form
      class="add-document-client"
      @submit="createDirection"
      :form-data="formData"
      :ok-text="'Сохранить'"
      cancel-text="Отменить"
  >
    <div class="add-document-client__title">
      <i class="icon role-client"/>
      Клиент: {{contractor}}
    </div>
    <ObSelect
        v-model="formData.locationStartUuid"
        label="Откуда"
        placeholder="Укажите начальную точку маршрута"
        :remote-opt="api.contract.getLocations"
        :is-auto-complete="true"
        display-exp="russian_name"
        data-qa="locationFrom"
        style="margin-bottom: 30px;"
    />
    <ObSelect
        v-model="formData.locationEndUuid"
        label="Куда"
        placeholder="Укажите конечную точку маршрута"
        :remote-opt="api.contract.getLocations"
        :is-auto-complete="true"
        display-exp="russian_name"
        data-qa="locationFrom"
        style="margin-bottom: 30px;"
    />
    <ObAlert
        text="Для этого направления будут действовать индивидуальные настройки по необходимым документам, их количеству и срокам предоставления"
        icon="info"
        :hideCloseButton="true"
        class="add-document-client__direction"
    />
    <div class="add-document-client__term">
      <b>Сроки для документов</b>
      <div class="add-document-client__term-list">
        <ObInput
            class="add-document-client__term-list-value"
            label="Срок предоставления"
            v-model="formData.docSettings.provisionTerm[0].term"
            placeholder="0"
            subTitle="дней"
            type="money:0"
            :isConvertMoney="false"
        />
        <ObInput
            class="add-document-client__term-list-value"
            label="Срок проверки исполнения"
            v-model="formData.docSettings.executionConfirmationTerm"
            placeholder="0"
            subTitle="дней"
            type="money:0"
            :isConvertMoney="false"
        />
        <ObInput
            class="add-document-client__term-list-value"
            label="Срок оплаты"
            v-model="formData.docSettings.paymentTerm"
            placeholder="0"
            subTitle="дней"
            type="money:0"
            :isConvertMoney="false"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
  import ObForm from 'common-components/src/obComponents/obForm';
  import ObSelect from 'common-components/src/obComponents/obSelect';
  import ObAlert from 'common-components/src/obComponents/obAlert';
  import ObInput from "common-components/src/obComponents/obInput";
  import api from '@/api';
  import {mapGetters, mapActions} from 'vuex';

  export default {
    name: "AddModal",
    components: {
      ObForm,
      ObSelect,
      ObAlert,
      ObInput
    },
    data() {
      return {
        formData: {
          locationStartUuid: '',
          locationEndUuid: '',
          docSettings: {
            provisionTerm: [
              {
                term: 0
              }
            ],
            executionConfirmationTerm: 0,
            paymentTerm: 0,
            docSettings: []
          }
        },
        api
      }
    },
    computed: {
      ...mapGetters({
        answerByServer: 'clicarSettings/answerByServer',
        list_customers: 'clicarSettings/list_customers',
        client_uuid: 'clicarSettings/client_uuid',
      }),
      contractor() {
        const title = this.list_customers.find(key => key.uuid === this.client_uuid);
        if (title) {
          return title.name;
        }
        return ''
      }
    },
    methods: {
      ...mapActions({
        addNewDirection: 'clicarSettings/addNewDirection',
        sortByCustomer: 'clicarSettings/sortByCustomer',
      }),
      async createDirection() {
        await this.addNewDirection(this.formData)
          .then(() => {
            if (this.answerByServer === 'success') {
              this.$notification({
                type: 'system_notification_success',
                message: 'Услугу сохранена'
              });
              this.sortByCustomer(this.client_uuid)
              this.$emit('closeAddModal')
            } else if (this.answerByServer === 'error') {
              this.$notification({
                type: 'system_notification_error',
                message: 'Данная услуга не может быть создана'
              })
            }
          })
      }
    }
  }
</script>

<style scoped lang="scss">
  .add-document-client {
    &__title {
      font-size: 14px;
      line-height: 20px;
      letter-spacing: 0.2px;
      color: $color-text-base;
      margin-bottom: 20px;
    }

    &__term {
      &-list {
        display: flex;
        margin-top: 10px;

        &-value {
          margin-right: 10px;

          &:last-child {
            margin-right: 0;
          }
        }
      }
    }
  }
</style>

<style lang="scss">
  .add-document-client__direction {
    margin-bottom: 30px;
  }
</style>
